#include <stdio.h>

int	tabflg;
int	labno	= 1;
FILE	*curbuf;
FILE	*obuf;

main(argc, argv)
char **argv;
{
/*
	A1 -> A
	A2    B
	A     O
	B1    C
	B2    D
	BE    L
	BF    P
	BT    J
	C1    E
	C2    F
	F     G
	H     H
	R     I
	S     K
	I     M
	M     N
	PU    U
	PO    Q
	PP    R

		*	+1
		S	+2
		C	+4
		1	+8

	z  -> 4
	c     10
	a     14
	e     20
	n     63
	*	+0100
*/

	int c, snlflg, nlflg, t, smode, m, ssmode, peekc;

	smode = nlflg = snlflg = ssmode = 0;
	if (argc>1)
		if (freopen(argv[1], "r", stdin) == NULL) {
			fprintf(stderr, "%s?\n", argv[1]);
			return(1);
		}
	if (argc>2) 
		if (freopen(argv[2], "w", stdout) == NULL) {
			fprintf(stderr, "%s?\n", argv[2]);
			return(1);
		}
	if ((obuf = fopen("cvopt.tmp", "w")) == NULL) {
		fprintf(stderr, "cvopt.tmp?\n");
		exit(1);
	}
	curbuf = obuf;
	printf(".data\n");
loop:
	c = getchar();
	if (c!='\n' && c!='\t')
		nlflg = 0;
	if (ssmode!=0 && c!='%') {
		ssmode = 0;
		curbuf = stdout;
#ifdef CROSS
		fprintf(curbuf, "L%d:<", labno++);
#else
		fprintf(curbuf, "L%d:\n.ascii\t/", labno++);
#endif
	}
	switch(c) {

	case EOF:
		fprintf(obuf, "0\n");
		fclose(obuf);
		fprintf(stdout, ".even\n");
		if (freopen("cvopt.tmp", "r", stdin) == NULL) {
			fprintf(stderr, "tmp?\n");
			exit(1);
		}
		while ((c = getchar()) != EOF)
			putchar(c);
		unlink("cvopt.tmp");
		return(0);

	case ':':
		if (!smode)
#ifdef CROSS
			fprintf(curbuf, "=.+2; 0"); else
#else
			fprintf(curbuf, "=.+2\n 0"); else
#endif
			put(':');
		goto loop;

#ifndef CROSS
	case ';':
		put('\n');
		goto loop;
#endif

	case 'A':
		if ((c=getchar())=='1' || c=='2') {
			put(c+'A'-'1');
			goto loop;
		}
		put('O');
		ungetc(c, stdin);
		goto loop;

	case 'B':
		switch (getchar()) {

		case '1':
			put('C');
			goto loop;

		case '2':
			put('D');
			goto loop;

		case 'E':
			put('L');
			goto loop;

		case 'F':
			put('P');
			goto loop;
		case 'T':
			put('J');
			goto loop;
		}
		put('?');
		goto loop;

	case 'C':
		put(getchar()+'E'-'1');
		goto loop;

	case 'F':
		put('G');
		goto subtre;

	case 'R':
		put('I');
		goto subtre2;

	case 'H':
		put('H');
		goto subtre;

	case 'I':
		put('M');
		goto loop;

	case 'P':
		switch (getchar()){
		case 'U':
			put('U');
			goto loop;
		case 'O':
			put('Q');
			goto loop;
		case 'P':
			put('R');
			goto loop;
		default:
			put('?');
			goto loop;
		}
	case 'S':
		put('K');
subtre:
		snlflg = 1;
subtre2:
		t = 'A';
l1:
		switch (c=getchar()) {

		case '*':
			t++;
			goto l1;

		case 'S':
			t =+ 2;
			goto l1;

		case 'C':
			t =+ 4;
			goto l1;

		case '1':
			t =+ 8;
			goto l1;

		case '2':
			t =+ 16;
			goto l1;
		}
		ungetc(c, stdin);
		put(t);
		goto loop;

	case '#':
		if((c = getchar())=='1') 
			put('#'); 
		else if(c == '{' || c == '[')
			{
			put('S');
			put(c);
			}
		else
			put('"');
		goto loop;

	case '%':
		if (smode)
			curbuf = obuf;
		if (ssmode==0) {
			if ((peekc=getchar())=='[') {
				curbuf = stdout;
				while((c=getchar())!=']')
					put(c);
				getchar();
#ifdef CROSS
				fprintf(curbuf, ";");
#else
				fprintf(curbuf, "\n");
#endif
				curbuf = obuf;
				goto loop;
			}
			ungetc(peekc, stdin);
		}
loop1:
		switch (c=getchar()) {

		case ' ':
		case '\t':
			goto loop1;
		case 'a':
			m = 16;
			t = flag();
			goto pf;

		case ',':
#ifdef CROSS
			put(';');
#else
			put('\n');
#endif
			goto loop1;

		case 'i':
			m = 12;
			t = flag();
			goto pf;
		case 'z':
			m = 4;
			t = flag();
			goto pf;

		case 'r':
			m = 9;
			t = flag();
			goto pf;

		case '1':
			m = 5;
			t = flag();
			goto pf;

		case 'c':
			t = 0;
			m = 8;
			goto pf;

		case 'e':
			t = flag();
			m = 20;
			goto pf;

		case 'n':
			t = flag();
			m = 63;
pf:
			if ((c=getchar())=='*')
				m =+ 0100; else
				ungetc(c, stdin);
#ifdef CROSS
			fprintf(curbuf, ".byte %o,%o", m, t);
#else
			fprintf(curbuf, ".byte %d,%d", m, t);
#endif
			goto loop1;
		case '[':
			fprintf(curbuf, "L%d=", labno++);
			while ((c=getchar())!=']')
				put(c);
			ssmode = 0;
			smode = 0;
			goto loop;

		case '\n':
			fprintf(curbuf, "\nL%d\n", labno);
			ssmode = 1;
			nlflg = 1;
			smode = 1;
			goto loop;
		}
		put(c);
		goto loop1;

	case '\t':
		if (nlflg) {
			nlflg = 0;
			goto loop;
		}
		if (smode) {
			tabflg++;
			goto loop;
		}
		put('\t');
		goto loop;

	case '\n':
		if (!smode)  {
			put('\n');
			goto loop;
		}
		if (nlflg) {
			nlflg = 0;
#ifdef CROSS
			fprintf(curbuf, "\\0>\n");
#else
			fprintf(curbuf, "\\0/\n");
#endif
			curbuf = obuf;
			smode = 0;
			goto loop;
		}
		if (!snlflg)
			fprintf(curbuf, "\\n");
		snlflg = 0;
#ifdef CROSS
		fprintf(curbuf, ">\n<");
#else
		fprintf(curbuf, "/\n.ascii\t/");
#endif
		nlflg = 1;
		goto loop;

	case 'X':
	case 'Y':
	case 'T':
		snlflg++;
		break;
#ifndef CROSS
	case '/':
		put ('|');
		goto loop;
#endif
	}
	put(c);
	goto loop;
}


flag() {
	register c, f;

	f = 0;
l1:
	switch(c=getchar()) {

	case 'w':
		f = 1;
		goto l1;

	case 'i':
		f = 2;
		goto l1;

	case 'b':
		f = 3;
		goto l1;

	case 'f':
		f = 4;
		goto l1;

	case 'd':
		f = 5;
		goto l1;

	case 'u':
		f = 9;
		goto l1;

	case 's':
		f = 6;
		goto l1;

	case 'l':
		f = 8;
		goto l1;

	case 'p':
		f =+ 16;
		goto l1;
	}
	ungetc(c, stdin);
	return(f);
}

put(c)
{
	if (tabflg) {
		tabflg = 0;
#ifdef CROSS
		fprintf(curbuf, ">;.byte %o;<", c+0200);
#else
		fprintf(curbuf, "/\n.byte %d\n.ascii /", c+0200);
#endif
	} else
		putc(c, curbuf);
}
