
/********************************************************************
 *
 *	TITLE:	   tools
 *
 *	DATE:	   05-26-82
 *
 *	ABSTRACT:  .
 *
 *	LANGUAGE DEPENDENCIES:
 *
 *		C86     VERSION 1.0
 *
 *********************************************************************/
#include <ctype.h>

	/*
	 *  External declerations
	 */

extern long time();

/********************************************************************
 *
 *	TITLE:	   coerice
 *
 *	CALLING SEQUENCE:
 *
 *		   coerice( name );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
coerice( name )
char *name;
{
	while( *name ) {
		if ( isalpha(*name) && isupper(*name) )
			*name = tolower(*name);

		++name;
	}
}

/********************************************************************
 *
 *	TITLE:	   lookup
 *
 *	CALLING SEQUENCE:
 *
 *		   lookup( table, name );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
lookup( table, name )
char *table[], name[];
{
int i;

	coerice( name );
	i = 0;
	while ( strncmp( table[i], name, strlen(name) ) && strcmp( table[i], "" ) ) 
		i++;

	return(i);

}

/********************************************************************
 *
 *	TITLE:	   roll
 *
 *	CALLING SEQUENCE:
 *
 *		   roll( min, max );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
unsigned roll( min, max )
unsigned min, max;
{

	return( min + rand() % (max - min + 1) );
}

/********************************************************************
 *
 *	TITLE:	   dice
 *
 *	CALLING SEQUENCE:
 *
 *		   dice();
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
dice()
{
	srand( (int) time(0) );
}

/********************************************************************
 *
 *	TITLE:	   setch
 *
 *	CALLING SEQUENCE:
 *
 *		   setch( value, buff, size );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
setch( value, buff, size )
char value, buff[];
unsigned size;
{
unsigned i;

	for( i = 0; i < size; i++ )
		buff[i] = value;
}

/********************************************************************
 *
 *	TITLE:	   compare
 *
 *	CALLING SEQUENCE:
 *
 *		   compare( value, buff, size );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
int compare( value, buff, size )
char value, buff[];
unsigned size;
{
unsigned i;

	for( i = 0; buff[i] == value && i < size; i++ )
		;

	return( (i == size) ? 0 : i );
}

